<?php
/*
Plugin Name: contentOVERVIEW
Plugin URI: http://fehertamas.com/contentoverview/
Description: This plugin creates an hierarchical overview about all used headers in your posting.
Version: 0.4.4
Author: Feher Tamas
Author URI: httep://fehertamas.com/

Copyright: Feher Tamas
License: GPL2+
*/

if( !defined( 'ABSPATH' ) ) exit;

class cow_contentoverview {
	var $cow_depth = 0;
	var $cow_last = 0;
	var $cow_hiar = array(0);
	var $cow_udus = array();
	var $cow_num = array();
	var $options;
	var $meta;

	function init() {
		$this->options = get_option( 'cow_contentoverview' );
		add_filter( 'the_content', array( &$this, 'cow_search' ) );
		add_filter( 'contentoverview', array( &$this, 'cow_toc' ) );
	}

	function cow_toc( $content ) {
  	global $post;
		$this->options = get_option( 'cow_contentoverview' );
		$this->cow_search( $post->post_content );

	  if ( is_array( $this->cow_num ) && sizeof( $this->cow_num ) > 0 )
  		return join ( '', $this->cow_num );
  		
    return;
	}

	function cow_search( $content ) {
  	global $post;
  	$this->meta = get_post_custom( $post->ID );
  	$this->cow_depth = 0;
  	$this->cow_last = 0;
  	$this->cow_hiar = array(0);
  	$this->cow_udus = array();
  	$this->cow_num = array();

  	if( $this->meta['_contentoverview_style_value'][0] == 'cow_contentoverview_style_none' ) {
		  return $content;
		  }
  	
  	if( $this->meta['_contentoverview_position_value'][0] != '' || $this->meta['_contentoverview_style_value'][0] != '' ) {
		  $this->options['method'] = $this->meta['_contentoverview_position_value'][0];
		  $this->options['style'] = $this->meta['_contentoverview_style_value'][0];
		  }
	
    if( !is_search() && !is_tag() && !is_author() && !is_day() && !is_month() && !is_year() && !is_category() ) {	
  		$content = preg_replace_callback( "/<h([0-6])[^>]*>(.*?)<\/h\\1>/i", array( &$this, 'cow_listing' ), $content );
    	  
    	/* BEFORE TEXT */  
  		if ( $this->options['method'] == 'cow_contentoverview_abgn' )
    	  $content = join ( '', $this->cow_num ).$content;
    	/* AFTER FIRST PARAGRAPH */  
  		elseif ( $this->options['method'] == 'cow_contentoverview_afpg' )
    	  $content = preg_replace( '/<span id=\"more/', join ( '', $this->cow_num ).'<span id="more', $content );
    	else
    	  $content = preg_replace( '/\$contentoverview/', '', $content );
    	  
      return $content;
    }
    
    if ( is_search() || is_tag() || is_author() || is_day() || is_month() || is_year() || is_category() )
      $content = preg_replace( '/\$contentoverview/', '', $content );

		return $content;
	}

	function cow_listing( $prcmatch ) {
	
	  if ( $this->cow_depth == 0 && ( $prcmatch[1] <= $this->cow_last || empty( $this->cow_last ) ) ) {
	    $this->cow_last = $prcmatch[1];
	  } 
	 
	  if ( $prcmatch[1] > $this->cow_last ) {
	    $this->cow_depth++;
	  } elseif ( $prcmatch[1] < $this->cow_last ) {
	  
	    if ( $this->cow_last - $prcmatch[1] > 1 ) {
	    
	      for ( $i = $this->cow_last - $prcmatch[1] - ( $this->cow_last - $prcmatch[1] - 1 ); $i <= $this->cow_depth; $i++ )
	        unset( $this->cow_hiar[$i] );
	    
	    } else {
	      unset( $this->cow_hiar[$this->cow_depth] );
	    }
	    
	    $this->cow_depth -= $this->cow_last - $prcmatch[1];
	  }
	  
	  $adus = preg_replace( '/([^a-z])/i', '', strtolower($prcmatch[2]) );
	  $adnu = '';
	  
	  while ( array_search ( $adus.$adnu, $this->cow_udus ) ) {
	    $adnu = ( empty( $adnu ) ) ? 0 : $adnu + 1;
	  }
	  
	  $this->cow_udus[] = $adus.$adnu;
	  $this->cow_hiar[$this->cow_depth] = ( !isset($this->cow_hiar[$this->cow_depth]) ) ? 1 : $this->cow_hiar[$this->cow_depth] + 1;
	  $cow_hiar = array();
	  $cow_ljoiner = '.';
	  $cow_joiner = '.';
	  
	  if ( $this->options['style'] != 'cow_contentoverview_style_decimal' ) {

	    foreach ( $this->cow_hiar as $key => $val ) {
  
        switch ( $this->options['style'] ) {
          case 'cow_contentoverview_style_loroman' :
      	    $cow_hiar[$key] = $this->decimal2roman( $val );
      	    break;
          case 'cow_contentoverview_style_uproman' :
      	    $cow_hiar[$key] = $this->decimal2roman( $val, 'high');
      	    break;
          case 'cow_contentoverview_style_indent' :
      	    $cow_hiar = array();
      	    $cow_ljoiner = '';
      	    $cow_joiner = '';
      	    break;
          case 'cow_contentoverview_style_disc' :
      	    $cow_hiar = array();
      	    $cow_ljoiner = '&bull;';
      	    $cow_joiner = '';
      	    break;
          case 'cow_contentoverview_style_circle' :
      	    $cow_hiar = array();
      	    $cow_ljoiner = '&omicron;';
      	    $cow_joiner = '';
      	    break;
          case 'cow_contentoverview_style_loalpha' || 'cow_contentoverview_style_upalpha' :
            $alext = 'low';
    
            if ( $this->options['style'] == 'cow_contentoverview_style_upalpha' )
              $alext = 'high';
    
            if ( $key == 0 )
      	      $cow_hiar[$key] = '<strong>'.$this->decimal2alpha( $val-1, $alext ).')</strong> ';
      	    else
      	      $cow_hiar[$key] = $val.'.';
      	    
      	    if ( $key > 0 && !isset ( $cow_hiar[$key+1] ) )
      	      $cow_hiar[0] = '<small>'.$this->decimal2alpha( $this->cow_hiar[0] - 1, $alext ).'</small> ';

      	    $cow_ljoiner = '';
      	    $cow_joiner = '';
      	    break;
          default :
      	    $cow_hiar[$key] = $val;
      	    break;
      	}
    	
    	}
  	
  	} else {
  	  $cow_hiar = $this->cow_hiar;
  	}
	  
	  $this->cow_num[] = '<p>'.str_repeat( '&nbsp;', 1 + ( $this->cow_depth * 5 ) ).join( $cow_hiar, $cow_ljoiner ).$cow_ljoiner.' <a href="#'.$adus.$adnu.'">'.$prcmatch[2].'</a></p>';
	  $this->cow_last = $prcmatch[1];
		return '<h'.$prcmatch[1].' id="'.$adus.(( $adnu > 0 ) ? $adnu : '' ).'">'.join( $cow_hiar, $cow_joiner ).$cow_joiner.' '.$prcmatch[2].'</h'.$prcmatch[1].'>';
	}

  function decimal2roman ( $dec, $ori = 'low' ) {
    $ret = ''; 
  
    if ( !is_numeric( $dec ) || $dec <= 0 || $dec > 3999)
      return false; 

    if ( $ori == 'low' )
      $rom = array( 'm' => 1000, 'd' => 500, 'c' => 100, 'l' => 50, 'x' => 10, 'v' => 5, 'i' => 1 ); 
    elseif ( $ori == 'high' )
      $rom = array( 'M' => 1000, 'D' => 500, 'C' => 100, 'L' => 50, 'X' => 10, 'V' => 5, 'I' => 1 ); 

    foreach ( $rom as $key => $val ) {
    
      if ( ( $num[$key] = floor( $dec / $val ) ) > 0 )
        $dec -= $num[$key] * $val; 
        
    }
    
    foreach ( $num as $key => $val ) { 
      $ret .= ( $val > 3 ) ? $key . $old_key : str_repeat ( $key, $val ); 
      $old_key = $key;                 
    }

    if ( $ori == 'low' )
      return str_replace ( array ( 'dcd', 'lxl', 'viv' ), array ( 'cm', 'xc', 'ix' ), $ret ); 
    elseif ( $ori == 'high' )
      return str_replace ( array ( 'DCD', 'LXL', 'VIV' ), array ( 'CM', 'XC', 'IX' ), $ret ); 
  }

  function decimal2alpha ( $dec, $ori = 'low' ) {
    $ret = ''; 
  
    if ( !is_numeric( $dec ) )
      return false; 

    if ( $ori == 'low' )
      $rom = array( 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z' ); 
    elseif ( $ori == 'high' )
      $rom = array( 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z' ); 
      
    if ( $dec > floor( $dec / count( $rom ) ) )
      $dec -= floor( $dec / count( $rom ) ) * count ( $rom );
      
    return $rom[$dec];  
  }
	
}

function contentoverview( $prefix, $suffix ) {
  $toc = apply_filters( 'contentoverview' );
  
  if( $toc )
    echo $prefix.$toc.$suffix;
    
}

if ( !is_admin() ) {
	$cow_contentoverview = new cow_contentoverview;
} else {
  load_plugin_textdomain( 'contentoverview', false, dirname( plugin_basename( __FILE__ ) ) );
	require( dirname( __FILE__ ) . '/contentoverview-admin.php' );
	$cow_contentoverview = new cow_contentoverview_admin;
	register_activation_hook( __FILE__, array( &$cow_contentoverview, 'activation_hook' ) );
}

add_action( 'init', array( &$cow_contentoverview, 'init' ) );
